# Transformation of Staging Data into M3 format via mapping file 
import pandas as pa
import json
import numpy as np

def tranform_data(mappingfile, mainsheet,stagingdata):

    # Read the file from given location
    #file_path = "D:\BVB_Mapping_Kundenstamm.xlsx"
    xls = pa.ExcelFile(mappingfile)

    # to read all sheets to a map
    sheet_to_df_map = {}
    for sheet_name in xls.sheet_names:
        sheet_to_df_map[sheet_name] = xls.parse(sheet_name)
        
    rows_list = []

    for tb_index,tb_row in stagingdata.iterrows():
        row_dict = {}
        for index,row in sheet_to_df_map[mainsheet].iterrows():
            #
            if index >=9:
                if row[33] and not row[33] is np.nan:
                    row_dict[row[15]] = tb_row[row[33]]
                else:
                    if row[36] == 'tbl':
                        tab = {}
                        for i,val in sheet_to_df_map[row[37]].iterrows():
                            if i >= 7:
                                tab[str(val[0])] = str(val[1])
                        if row[38] and not row[38] is np.nan:
                            if tb_row[row[38]] in tab:
                                row_dict[row[15]] = tab[tb_row[row[38]]]
                            else:
                                row_dict[row[15]] = tb_row[row[38]]
                    elif row[36] == 'const':
                        row_dict[row[15]] = row[37]
        rows_list.append(row_dict)
    return pa.DataFrame(rows_list)